# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulpcore.configuration import Configuration


class DomainBackendMigrator(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'storage_class': 'StorageClassEnum',
        'storage_settings': 'object'
    }

    attribute_map = {
        'storage_class': 'storage_class',
        'storage_settings': 'storage_settings'
    }

    def __init__(self, storage_class=None, storage_settings=None, local_vars_configuration=None):  # noqa: E501
        """DomainBackendMigrator - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._storage_class = None
        self._storage_settings = None
        self.discriminator = None

        self.storage_class = storage_class
        self.storage_settings = storage_settings

    @property
    def storage_class(self):
        """Gets the storage_class of this DomainBackendMigrator.  # noqa: E501

        The new backend storage class to migrate to.  * `pulpcore.app.models.storage.FileSystem` - Use local filesystem as storage * `storages.backends.s3boto3.S3Boto3Storage` - Use Amazon S3 as storage * `storages.backends.azure_storage.AzureStorage` - Use Azure Blob as storage  # noqa: E501

        :return: The storage_class of this DomainBackendMigrator.  # noqa: E501
        :rtype: StorageClassEnum
        """
        return self._storage_class

    @storage_class.setter
    def storage_class(self, storage_class):
        """Sets the storage_class of this DomainBackendMigrator.

        The new backend storage class to migrate to.  * `pulpcore.app.models.storage.FileSystem` - Use local filesystem as storage * `storages.backends.s3boto3.S3Boto3Storage` - Use Amazon S3 as storage * `storages.backends.azure_storage.AzureStorage` - Use Azure Blob as storage  # noqa: E501

        :param storage_class: The storage_class of this DomainBackendMigrator.  # noqa: E501
        :type: StorageClassEnum
        """
        if self.local_vars_configuration.client_side_validation and storage_class is None:  # noqa: E501
            raise ValueError("Invalid value for `storage_class`, must not be `None`")  # noqa: E501

        self._storage_class = storage_class

    @property
    def storage_settings(self):
        """Gets the storage_settings of this DomainBackendMigrator.  # noqa: E501

        The settings for the new storage class to migrate to.  # noqa: E501

        :return: The storage_settings of this DomainBackendMigrator.  # noqa: E501
        :rtype: object
        """
        return self._storage_settings

    @storage_settings.setter
    def storage_settings(self, storage_settings):
        """Sets the storage_settings of this DomainBackendMigrator.

        The settings for the new storage class to migrate to.  # noqa: E501

        :param storage_settings: The storage_settings of this DomainBackendMigrator.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and storage_settings is None:  # noqa: E501
            raise ValueError("Invalid value for `storage_settings`, must not be `None`")  # noqa: E501

        self._storage_settings = storage_settings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DomainBackendMigrator):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DomainBackendMigrator):
            return True

        return self.to_dict() != other.to_dict()
